/** 
 * @class dcel::tAttrib
 *  
 * @brief A class implementing an edge of the DCEL data structure.
 *
 * @author
 * Marcelo Ferreira Siqueira @n
 * Universidade Federal de Mato Grosso do Sul, @n
 * Departamento de Computacao e Estatistica, @n
 * marcelo at dct (dot) ufms (dot) br
 *
 * @version 1.0
 * @date Abril 2008
 *
 * @attention This program is distributed  WITHOUT ANY WARRANTY,  and
 *            it may be freely redistributed under the condition that
 *            the copyright notices are  not  removed,  and  no
 *            compensation  is  received. Private, research, and
 *            institutional use  is free. Distribution of this code as
 *            part of a commercial system is permissible ONLY BY DIRECT
 *            ARRANGEMENT WITH THE AUTHOR.
 */


#ifndef ATTRIB_H_
#define ATTRIB_H_


#include "smartptr.h"
#include "dataobj.h"


namespace dcel {

  
  class tAttrib : public tDataObject {
  public:
    /**
    * Defines Self as this class
    */    
    typedef tAttrib                 Self;


    /**
    * Defines Pointer as smart pointer to this class.
    */    
    typedef tSmartPtr<Self>       Pointer;


    /**
    * Defines ConstPointer as a const smart pointer to this class.
    */    
    typedef tSmartPtr<const Self> ConstPointer;


    /**
    * Method for creating an instance of this object.
    */
    static Pointer NEW()
    {
      tAttrib *dumbPtr = new tAttrib;
      Pointer smartPtr(dumbPtr);

      return smartPtr;
    }


    /**
    * Destructor.
    */
    virtual ~tAttrib() {}

  protected:
    /**
    * Default constructor.
    */
    tAttrib() {}

  };


}


#endif   // ATTRIB_H_
