/** 
  * 
  * @brief  A  file  containing   macros  related  to  the  DCEL  data
  * structure.
  *
  * @author
  * Marcelo Ferreira Siqueira @n
  * Universidade Federal de Mato Grosso do Sul, @n
  * Departamento de Computacao e Estatistica, @n
  * marcelo at dct (dot) ufms (dot) br
  *
  * @version 1.0
  * @date Abril 2008
  *
  * @attention This program is distributed  WITHOUT ANY WARRANTY,  and
  *            it may be freely redistributed under the condition that
  *            the copyright notices are  not  removed,  and  no
  *            compensation  is  received. Private, research, and
  *            institutional use  is free. Distribution of this code as
  *            part of a commercial system is permissible ONLY BY DIRECT
  *            ARRANGEMENT WITH THE AUTHOR.
  */

#include <iostream>

#ifndef DCEL_H_
#define DCEL_H_


/**
 * @brief Return  the mate  (if any) of  a given  half-edge.  
 *
 * @details  This  macro  is  used  to  obtain the  mate  of  a  given
 * half-edge. The  given half-edge is  represented by a  smart pointer
 * and the macro returns another smart pointer to its mate.
 *
 * @param h - A smart pointer to a half-edge.
 *
 * @return A smart pointer to the mate of the given half-edge.
 */
#define MATE(h) h->get_edge()->get_mate(h)



#endif   // __macros_h
