//  ===================================================================
//
//  Program:   common
//  Module:    macros.h
//  Language:  C++
//  Date:      June 2004
//  Version:   1.0.0
//
//  Copyright (c) 2004
//
//  Marcelo Siqueira
//
//  Graduate Student
//  Department of Computer and Information Science
//  Moore School Building
//  200 South 33rd Street, Suite #62
//  Philadelphia, PA 19104-6389
//  Phone No.: (215) 898-5879
//
//  marcelos@seas.upenn.edu
//
// This program  is distributed  WITHOUT ANY WARRANTY,  and it  may be
// freely redistributed under the condition that the copyright notices
// are  not  removed,  and  no  compensation  is  received.   Private,
// research, and institutional use  is free. Distribution of this code
// as  part of  a  commercial  system is  permissible  ONLY BY  DIRECT
// ARRANGEMENT WITH THE AUTHOR.
//
//  ==================================================================

#include <iostream>
#include <sstream>

#ifndef __macros_h_
#define __macros_h_

// -------------------------------------------------------------------
//
// This macro  is used  to create an  instance of a  particular object
// using the  C++ operator "new", and  then return a  smart pointer to
// this object.
//
// -------------------------------------------------------------------
#define newMacro(c) \
static Pointer New(void) \
{ \
  c *dumbPtr = new c; \
  Pointer smartPtr(dumbPtr); \
  return smartPtr; \
}

#define treatException(e) \
  std::cout << "Exception: " << e.getDescription() << std::endl \
            << "File: " << e.getFile() << std::endl \
            << "Line: " << e.getLine() << std::endl

#define ASSERT(c) \
  if (!(c)) { \
    std::stringstream ss (std::stringstream::in |       \
                          std::stringstream::out);      \
    ss << "Fatal error: contact developer.";            \
    throw tExceptionObject(__FILE__,__LINE__,ss.str()); \
  }  

#endif   // __macros_h
